package de.pheerai.buzzer.data

import java.util.*

object SessionStorage {
    val playerSessions = synchronisedCollectionOf<PlayerSocket>()
    val gameModeratorSessions = synchronisedCollectionOf<GameModeratorSocket>()
}

fun <T : Any> synchronisedCollectionOf(vararg data: T): MutableCollection<T> {
    val list = LinkedList<T>()
    list.addAll(data)
    return Collections.synchronizedCollection(list)
}
