package de.pheerai.buzzer.handlers

import de.pheerai.buzzer.data.GameModeratorSocket
import de.pheerai.buzzer.data.SessionStorage
import io.ktor.websocket.*
import kotlinx.coroutines.isActive
import org.slf4j.Logger

suspend fun WebSocketSession.handleGameModeratorSocket(log: Logger) {
    SessionStorage.gameModeratorSessions.add(GameModeratorSocket(this))
    for (frame in incoming) {
        when (frame) {
            is Frame.Text -> {
                val text = frame.readText()
                log.info("GM Socket received $text")
                SessionStorage.playerSessions.filter { it.session.isActive }
                    .forEach { it.session.send(text) }
            }
            else -> {}
        }
    }
}
